
#property copyright "23510"
#property link      ""
extern double TakeProfit = 30;
extern double StopLoss   = 50;
extern double Lots       = 0.1;
extern double Risk       = 3.0;
extern double TrailingStop = 15;
extern string comment    = "HA-EAv02";
extern int    magic      =234234;

int 
sell_orders,buy_orders,sell_limit_orders,buy_limit_orders,sell_stop_orders,buy_stop_orders,count,
total,cnt,ticket;
double index2,index3,previndex2,previndex3,sll,sls,tpl,tps,balance;

bool newbar;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
lots();
index2 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 2, 1) ; // gets index2 
index3 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 3, 1) ; // gets index3 
previndex2 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 2, 2) ; // gets index2 
previndex3 = iCustom(Symbol(), 0, "Heiken Ashi", 2, 6, 3, 2, 3, 2) ; // gets index3 

total = OrdersTotal();
sll = NormalizeDouble(Ask-StopLoss*Point,Digits);
tpl = NormalizeDouble(Ask+TakeProfit*Point,Digits);
sls = NormalizeDouble(Bid+StopLoss*Point,Digits);
tps = NormalizeDouble(Bid-TakeProfit*Point,Digits);
if(total==0)balance=AccountBalance();

if(newbar()==true)
{
if (total==0&&previndex3<previndex2&&index3>index2)
  {
   ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,sll,tpl,comment,magic,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
        }
    
   
    if(newbar()==true)
    {
if(total==0&&previndex3>previndex2&&index3<index2)
{
ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,sls,tps,comment,magic,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
     }
   }     
 for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(Volume[0]<5&&index3<index2)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(Volume[0]<5&&index3>index2)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+

bool newbar()
{
  static datetime lastbar = 0;
  datetime currbar = Time[0];
  if(lastbar != currbar)  //Will always be true for the first run.
    {
      lastbar = currbar;
      return(true);
    }
  else
    return(false);
}

void lots()
    {
/////////////////////////////////
Lots=NormalizeDouble(((balance/100)/100)*Risk,MarketInfo(Symbol(),MODE_LOTSIZE));
if(Lots<MarketInfo(Symbol(),MODE_MINLOT)){Lots=MarketInfo(Symbol(),MODE_MINLOT);}
if(Lots>MarketInfo(Symbol(),MODE_MAXLOT)){Lots=MarketInfo(Symbol(),MODE_MAXLOT);}
/////////////////////////////////
 return;
    }